import model.UserAuthorize
import model.Role
import java.security.SecureRandom
import java.security.spec.KeySpec
import java.time.LocalDate
import javax.crypto.SecretKey
import javax.crypto.SecretKeyFactory
import javax.crypto.spec.PBEKeySpec
import java.util.Base64

val authorizeList = mutableListOf<UserAuthorize>()
val salt = "sallllt"
private const val HASH_LENGTH = 256
private const val ITERATIONS = 65536

fun main(){
    while (true){
        println("1) registration")
        println("2) authorization")
        var choosen = readln()
        if (choosen == "1"){
            authorizeList.add(registration())
            authorizeList.forEach{
                println(it.userId)
                println(it.email)
                println(it.password)
                println(it.login)
                println(it.role.roleName)
            }
        }
        else{
            println(authorization())
        }
    }
}

fun registration(): UserAuthorize{
    println("email")
    val userEmail = readlnOrNull()
    checkNotNull(userEmail)
    require(userEmail.contains("@")){
        "add @ to email"
    }

    println("password")
    val userPassword = readlnOrNull()
    checkNotNull(userPassword)
    require(userPassword.length >= 8){
        "more longer password"
    }

    println("password again")
    val userPasswordTwo = readlnOrNull()
    checkNotNull(userPasswordTwo)
    require(userPassword == userPasswordTwo){
        "nea"
    }

    println("login")
    val userLogin = readlnOrNull()
    checkNotNull(userLogin)
    require(userLogin.length >= 4){
        "more longer login"
    }

    return UserAuthorize(
        authorizeList.size + 1,
        login = userLogin,
        password = hashPassword(userPassword, salt),
        lastAuthorizeDate = LocalDate.now(),
        email = userEmail,
        role = Role(
            roleId = 1,
            roleName = "User"
        )
    )
}

fun authorization(): String{
    println("email")
    val userEmail = readlnOrNull()
    checkNotNull(userEmail)
    val user = authorizeList.find { it.email == userEmail }
    require(user != null){
        "no user with that email"
    }

    println("password")
    val userPassword = readlnOrNull()
    checkNotNull(userPassword)
    require(user.password == hashPassword(userPassword, salt)){
        "incorrect password"
    }

    user.lastAuthorizeDate = LocalDate.now()

    return user.role.roleName
}

fun hashPassword(password: String, salt: String): String {
    val saltBytes = Base64.getDecoder().decode(salt)
    val spec = PBEKeySpec(password.toCharArray(), saltBytes, ITERATIONS, HASH_LENGTH)
    val factory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA256")
    val hash = factory.generateSecret(spec).encoded
    return Base64.getEncoder().encodeToString(hash)
}
